
        
    
  #include "gameramodule.hpp"
  #include "knnmodule.hpp"

        #include "misc_free_functions.hpp"
  
    #include <string>
  #include <stdexcept>
  #include "Python.h"
  #include <list>

  using namespace Gamera;
  
        
      extern "C" {
#ifndef _MSC_VER
    void init_misc_free_functions(void);
#endif
                  static PyObject* call_range_of_float(PyObject* self, PyObject* args);
            }

          static PyMethodDef _misc_free_functions_methods[] = {
                  { CHAR_PTR_CAST "range_of_float",
          call_range_of_float, METH_VARARGS,
          CHAR_PTR_CAST "**range_of_float** ()\n\nReturns a tuple ``(float_min, float_max)`` containing the range\nof a float variable on the used operating system, as given by\n``std::numeric_limits<float>``.\n\nThis should be the same as ``sys.float_info.min`` and ``sys.float_info.max``,\nbut these have been introduced into python as late as 2.6, so we need an own\nimplementation for backward compatibility.\n"        },
              { NULL }
  };

                static PyObject* call_range_of_float(PyObject* self, PyObject* args) {
            
      PyErr_Clear();
                                                                        PyObject* return_arg;
PyObject* return_pyarg;
                          
                                 
      
              try {
                                    return_arg=
                        range_of_float();
                  } catch (std::exception& e) {
          PyErr_SetString(PyExc_RuntimeError, e.what());
          return 0;
        }
      
                                            if (return_arg== NULL) {
              if (PyErr_Occurred() == NULL) {
                Py_INCREF(Py_None);
                return Py_None;
               } else
                return NULL;
            } else {
              return_pyarg = return_arg;              return return_pyarg;
            }
                              }
      
  DL_EXPORT(void) init_misc_free_functions(void) {
    Py_InitModule(CHAR_PTR_CAST "_misc_free_functions", _misc_free_functions_methods);
  }
  

